require "td"

local storytable =
{
    {
        {
            --not sure why this is needed here, but couldn't get the zoom to work otherwise
            condition = story.Story:elapsedcheck(.1),
        },
        {
            condition = story.Story:elapsedcheck(1),
            action = function()
                game.player.zoom = .4
                game.player.teleport({x=28, y=0})
                mainstory:enable_next_wave_button()
            end
        },
    }
}

local tdconfig =
{
    hp = 10,
    target_pos = game.getentitybytag("target").position,
    res_rect = {{x=38, y=-15}, {x=65, y=33}}, --rect in which resource buildings can be placed
    spawn_positions = { game.getentitybytag("spawn").position },
    enabled_recipes =
    {
        "turret-laser1",
        "coffee",
        "science",
    },
    enabled_technologies =
    {
        "turret-laser2",
        "turret-rocket",
        "turret-grenade",
    },
    starting_equipment =
    {
        {name="turret-laser1", count=5},
        {name="stone-wall", count=100},
        {name="money", count=30},
    },
    storytable = storytable,
    waves =
    {
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=3, pos=1},
            },
        },
        ---[[
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="medium-biter", num=1, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="medium-biter", num=1, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="medium-biter", num=3, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=10, pos=1},
                {type="medium-biter", num=3, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=10, pos=1},
                {type="medium-biter", num=5, pos=1},
                {type="big-biter", num=3, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="medium-biter", num=10, pos=1},
                {type="big-biter", num=5, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="medium-biter", num=5, pos=1},
                {type="big-biter", num=15, pos=1},
            },
        },
        --]]
    }
}

mainstory = td.TDStory:new(tdconfig)

game.oninit(function()
    mainstory:init()
end)

game.onsave(function()
    glob.storydata = mainstory:export()
end)

game.onload(function()
    mainstory:import(glob.storydata)
end)

game.onevent(defines.events, function(event)
    mainstory:update(event, "level-02")
end)
