require "td"

local storytable =
{
    {
        {
            --not sure why this is needed here, but couldn't get the zoom to work otherwise
            condition = story.Story:elapsedcheck(.1),
        },
        {
            condition = story.Story:elapsedcheck(1),
            action = function()
                game.player.zoom = .4
                mainstory:enable_next_wave_button()
            end
        },
    }
}

local tdconfig =
{
    hp = 10,
    target_pos = game.getentitybytag("target").position,
    res_rect = {{x=1, y=32}, {x=33, y=49}}, --rect in which resource buildings can be placed
    spawn_positions =
    {
        game.getentitybytag("spawn1").position,
        game.getentitybytag("spawn2").position,
    },
    enabled_recipes =
    {
        "turret-laser1",
        "coffee",
        "science",
    },
    enabled_technologies =
    {
        "turret-laser2",
        "turret-rocket",
        "turret-grenade",
    },
    starting_equipment =
    {
        {name="turret-laser1", count=10},
        {name="stone-wall", count=100},
        {name="money", count=50},
    },
    storytable = storytable,
    waves =
    {
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=2, pos=1},
                {type="small-biter", num=2, pos=2},
            },
        },
        ---[[
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=3, pos=1},
                {type="small-biter", num=2, pos=2},
                {type="medium-biter", num=1, pos=2},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=3, pos=1},
                {type="small-biter", num=3, pos=2},
                {type="medium-biter", num=1, pos=1},
                {type="medium-biter", num=1, pos=2},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=3, pos=2},
                {type="medium-biter", num=3, pos=1},
                {type="medium-biter", num=5, pos=2},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=10, pos=2},
                {type="medium-biter", num=3, pos=1},
                {type="medium-biter", num=3, pos=2},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=10, pos=1},
                {type="small-biter", num=10, pos=2},
                {type="medium-biter", num=5, pos=1},
                {type="medium-biter", num=5, pos=2},
                {type="big-biter", num=3, pos=1},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=5, pos=2},
                {type="medium-biter", num=10, pos=1},
                {type="medium-biter", num=10, pos=2},
                {type="big-biter", num=5, pos=1},
                {type="big-biter", num=5, pos=2},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=5, pos=2},
                {type="medium-biter", num=10, pos=1},
                {type="medium-biter", num=5, pos=2},
                {type="big-biter", num=10, pos=1},
                {type="big-biter", num=15, pos=2},
            },
        },
        --]]
    }
}

mainstory = td.TDStory:new(tdconfig)

game.oninit(function()
    mainstory:init()

    --can't select science in the map editor for this map. probably because i started editing when
    --that recipe was disabled and enabling it afterwards doesn't help anymore.
    --i don't feel like recreating the whole map, so...
    game.getentitybytag("bla").recipe = "science"
    game.daytime = .5
end)

game.onsave(function()
    glob.storydata = mainstory:export()
end)

game.onload(function()
    mainstory:import(glob.storydata)
end)

game.onevent(defines.events, function(event)
    mainstory:update(event, "level-03")
end)
