require "td"

local storytable =
{
    {
        {
            --not sure why this is needed here, but couldn't get the zoom to work otherwise
            condition = story.Story:elapsedcheck(.1),
        },
        {
            condition = story.Story:elapsedcheck(1),
            action = function() game.player.zoom = .4 end
        },
        {
            condition = story.Story:elapsedcheck(.1),
            action = function()
                game.showmessagedialog{text={"save-the-beer"},
                                       pointto={type="entity", entity=game.getentitybytag("target")}}
                mainstory:enable_next_wave_button()
            end
        },
    }
}

local tdconfig =
{
    hp = 10,
    target_pos = game.getentitybytag("target").position,
    res_rect = {{x=-15, y=-22}, {x=18, y=5}}, --rect in which resource buildings can be placed
    spawn_positions =
    {
        game.getentitybytag("spawn1").position,
        game.getentitybytag("spawn2").position,
        game.getentitybytag("spawn3").position,
    },
    enabled_recipes =
    {
        "turret-laser1",
        "coffee",
        "science",
    },
    enabled_technologies =
    {
        "turret-laser2",
        "turret-rocket",
        "turret-grenade",
    },
    starting_equipment =
    {
        {name="turret-laser1", count=10},
        {name="stone-wall", count=100},
        {name="money", count=50},
    },
    storytable = storytable,
    waves =
    {
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=2, pos=1},
                {type="small-biter", num=2, pos=2},
                {type="small-biter", num=1, pos=3},
            },
        },
        ---[[
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=3, pos=1},
                {type="small-biter", num=2, pos=2},
                {type="medium-biter", num=1, pos=2},
                {type="medium-biter", num=1, pos=3},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=3, pos=1},
                {type="small-biter", num=3, pos=2},
                {type="small-biter", num=3, pos=3},
                {type="medium-biter", num=1, pos=1},
                {type="medium-biter", num=2, pos=2},
                {type="medium-biter", num=1, pos=3},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=3, pos=2},
                {type="small-biter", num=3, pos=3},
                {type="medium-biter", num=3, pos=1},
                {type="medium-biter", num=5, pos=2},
                {type="medium-biter", num=2, pos=3},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=10, pos=2},
                {type="small-biter", num=5, pos=3},
                {type="medium-biter", num=3, pos=1},
                {type="medium-biter", num=3, pos=2},
                {type="medium-biter", num=2, pos=3},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=10, pos=1},
                {type="small-biter", num=10, pos=2},
                {type="small-biter", num=5, pos=3},
                {type="medium-biter", num=5, pos=1},
                {type="medium-biter", num=5, pos=2},
                {type="medium-biter", num=5, pos=3},
                {type="big-biter", num=3, pos=3},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=5, pos=2},
                {type="small-biter", num=5, pos=3},
                {type="medium-biter", num=10, pos=1},
                {type="medium-biter", num=10, pos=2},
                {type="medium-biter", num=10, pos=3},
                {type="big-biter", num=5, pos=1},
                {type="big-biter", num=5, pos=2},
                {type="big-biter", num=5, pos=3},
            },
        },
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="small-biter", num=5, pos=2},
                {type="small-biter", num=5, pos=3},
                {type="medium-biter", num=10, pos=1},
                {type="medium-biter", num=5, pos=2},
                {type="medium-biter", num=5, pos=3},
                {type="big-biter", num=10, pos=1},
                {type="big-biter", num=15, pos=2},
                {type="big-biter", num=10, pos=3},
            },
        },
        --]]
    }
}

mainstory = td.TDStory:new(tdconfig)

game.oninit(function()
    mainstory:init()
    game.getentitybytag("target").fluidbox[1] = { type="beer", amount=1900 }
end)

game.onsave(function()
    glob.storydata = mainstory:export()
end)

game.onload(function()
    mainstory:import(glob.storydata)
end)

game.onevent(defines.events, function(event)
    mainstory:update(event, "", function() game.player.setendingscreendata({"game-won"}, "") end)
end)
