require "td"

local storytable =
{
    {
        {
            condition = story.Story:elapsedcheck(1),
            action = function()
                game.showmessagedialog{text={"tutorial-intro"}} --FIXME this shouldn't point at anything
                --mainstory:enable_next_wave_button()
            end
        },
        ---[[
        {
            condition = story.Story:elapsedcheck(1),
            action = function() game.player.zoom = .35 end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-spawn"},
                                       pointto={type="entity", entity=game.getentitybytag("spawn")}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-target"},
                                       pointto={type="entity", entity=game.getentitybytag("target")}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-maze"},
                                       pointto={type="position", position={x=0, y=0}}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-blocking"},
                                       pointto={type="position", position={x=0, y=0}}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-sand"},
                                       pointto={type="position", position={x=-11, y=18}}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-crafting"}}
            end
        },
        {
            action = function()
                game.player.teleport({x=-17, y=-23})
                game.player.zoom = 1
            end
        },
        {
            condition = story.Story:elapsedcheck(.1),
            action = function()
                game.showmessagedialog{text={"tutorial-gold"},
                                       pointto={type="position", position={x=-29, y=-26}}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-stone"},
                                       pointto={type="position", position={x=-19, y=-29}}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-science"},
                                       pointto={type="position", position={x=-8, y=-29}}}
            end
        },
        {
            action = function()
                game.player.teleport({x=0, y=0})
                game.player.zoom = .4
            end
        },
        {
            condition = story.Story:elapsedcheck(.1),
            action = function()
                game.showmessagedialog{text={"tutorial-drills"}}
            end
        },
        {
            action = function()
                mainstory:enable_next_wave_button()
                game.showmessagedialog{text={"tutorial-waves"}, pointto={type="goal"}}
            end
        },
        {
            action = function()
                game.showmessagedialog{text={"tutorial-goodluck"}}
            end
        },
        --]]
    }
}

local tdconfig =
{
    hp = 5,
    target_pos = game.getentitybytag("target").position,
    res_rect = {{x=-32, y=-32}, {x=0, y=-13}}, --rect in which resource buildings can be placed
    spawn_positions = { game.getentitybytag("spawn").position },
    enabled_recipes =
    {
        "turret-laser1",
        "coffee",
        "science",
    },
    enabled_technologies =
    {
        "turret-laser2",
    },
    starting_equipment =
    {
        {name="turret-laser1", count=5},
        {name="stone-wall", count=50},
        {name="money", count=30},
    },
    storytable = storytable,
    waves =
    {
        {
            delay = 90,
            spawns =
            {
                {type="small-biter", num=3, pos=1},
            },
        },
        ---[[
        {
            delay = 120,
            spawns =
            {
                {type="small-biter", num=5, pos=1},
                {type="medium-biter", num=1, pos=1},
            },
        },
        {
            delay = 150,
            spawns =
            {
                {type="small-biter", num=10, pos=1},
                {type="medium-biter", num=3, pos=1},
            },
        },
        {
            delay = 150,
            spawns =
            {
                {type="small-biter", num=10, pos=1},
                {type="medium-biter", num=5, pos=1},
                {type="big-biter", num=3, pos=1},
            },
        },
        --]]
    }
}

mainstory = td.TDStory:new(tdconfig)

game.oninit(function()
    mainstory:init()
end)

game.onsave(function()
    glob.storydata = mainstory:export()
end)

game.onload(function()
    mainstory:import(glob.storydata)
end)

game.onevent(defines.events, function(event)
    mainstory:update(event, "level-01")
end)
