#macro turret(r, g, b)
#local base_height     = .5;
#local segment1_height = 1;
#local segment1_radius = .3;
#local segment2_height = 1;
#local segment2_radius = .2;
#local cone_height     = .75;
#local cone_radius     = .25;

#local cur_height = 0;

#local base_texture = texture {
    pigment
    {
        marble
        color_map
        {
            [0.0 rgb <r, g, b>]
            [0.8 rgb <.4,.4,.4>]
        }
        turbulence .5
        scale .1
    }
}

#local segment_texture = texture { pigment { color rgb <.4, .4, .4> } }

union
{
    box
    {
        <.5, cur_height, .5>, <-.5, cur_height + base_height, -.5>
        texture { base_texture }
    }
#local cur_height = cur_height + base_height;

#if (clock > 0)
#if (clock < .5)
#local h = segment1_height*clock*2;
#else
#local h = segment1_height;
#end
    cylinder
    {
        <0, cur_height, 0> <0, cur_height + h, 0> segment1_radius
        texture { segment_texture }
    }
#local cur_height = cur_height + h;

#if (clock > .5)
#local h = segment2_height*(clock-.5)*2;
    cylinder
    {
        <0, cur_height, 0> <0, cur_height + h, 0> segment2_radius
        texture { segment_texture }
    }
#local cur_height = cur_height + h;
#end
#end

    cone
    {
        <0, cur_height, 0> 0 <0, cur_height + cone_height, 0> cone_radius
        texture { base_texture }
    }
}
#end
